package main

import (
	"image"
	"image/color"
	"image/png"
	"os"

	"github.com/nfnt/resize"
)

const InputImagePath = "convert_me.png"
const OutputImagePath = "convert_me_resized.png"

func main() {
	in, _ := os.Open(InputImagePath)
	img, _, _ := image.Decode(in)
	in.Close()

	newImg := image.NewYCbCr(image.Rect(0, 0, img.Bounds().Dx(), img.Bounds().Dy()),
		image.YCbCrSubsampleRatio411)
	for y := 0; y < newImg.Bounds().Dy(); y++ {
		for x := 0; x < newImg.Bounds().Dx(); x++ {
			r, g, b, _ := img.At(x, y).RGBA()
			yVal, cb, cr := color.RGBToYCbCr(uint8(r>>8), uint8(g>>8), uint8(b>>8))
			newImg.Y[newImg.YOffset(x, y)] = yVal
			newImg.Cb[newImg.COffset(x, y)] = cb
			newImg.Cr[newImg.COffset(x, y)] = cr
		}
	}

	resized := resize.Resize(256, 256, newImg, resize.Bilinear)
	out, _ := os.Create(OutputImagePath)
	png.Encode(out, resized)
	out.Close()
}
